'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var legacyIR = require('apollo-codegen-core/lib/compiler/legacyIR');

exports.OperationType = void 0;

(function (OperationType) {
  OperationType["Query"] = "query";
  OperationType["Mutation"] = "mutation";
  OperationType["Subscription"] = "subscription";
})(exports.OperationType || (exports.OperationType = {}));

function isOperation(operationOrFragment) {
  return Object.prototype.hasOwnProperty.call(operationOrFragment, 'operationName');
}
function isTypedVariable(variable) {
  return variable.type != null;
}
const compile = legacyIR.compileToLegacyIR;

exports.compile = compile;
exports.isOperation = isOperation;
exports.isTypedVariable = isTypedVariable;
