import { compileToLegacyIR } from 'apollo-codegen-core/lib/compiler/legacyIR';

let OperationType;

(function (OperationType) {
  OperationType["Query"] = "query";
  OperationType["Mutation"] = "mutation";
  OperationType["Subscription"] = "subscription";
})(OperationType || (OperationType = {}));

function isOperation(operationOrFragment) {
  return Object.prototype.hasOwnProperty.call(operationOrFragment, 'operationName');
}
function isTypedVariable(variable) {
  return variable.type != null;
}
const compile = compileToLegacyIR;

export { OperationType, compile, isOperation, isTypedVariable };
